
#define NPALMMESHES    5

typedef struct {
          float   left, right, top, bottom, near, far, rl, tb;
          int     prevx, prevy;
          float   viewer_rvec[4], viewer_rangle;
          GLfloat eyepos[4];
          GLfloat mm[16], mmti[16], vm[16], pm[16], vpm[16];
          float   speed, model_rot_angle0, model_rot_angle;
          char    animation;
        } myglwindata;

extern float model_rot_axis[3];
extern float viewer_pos0[4];

extern char  meshsw[NPALMMESHES];
extern GPUmesh *mymesh[5];

void SetVPMatrix ( GLfloat vm[16], GLfloat pm[16], GLfloat ep[4] );
void SetupModelMatrix ( myglwindata *wd, float axis[3], float angle );
void InitViewMatrix ( myglwindata *wd );
char RotateViewer ( myglwindata *wd, float width, float height,
                    int delta_xi, int delta_eta );

void LoadMyShaders ( void );
void InitMyObject ( void );
void DestroyMyObject ( void );
void DestroyMyShaders ( void );

void DrawMyScene ( void );

