
typedef struct {
    char degree;
    int  firsthalfedge;
  } BSMfacet, BSMvertex;

typedef struct {
    int v0, v1;
    int facetnum;
    int otherhalf;
  } BSMhalfedge;

typedef struct CPUmesh {
    int         nsattr;
    int         nv, nhe, nfac;
    BSMvertex   *mv;
    BSMhalfedge *mhe;
    BSMfacet    *mfac;
    int         *mvhei, *mfhei;
    float       *vc;
  } CPUmesh;

typedef struct GPUmesh {
    int    nsattr;
    int    nv, nhe, nfac;
    GLuint mbuf[3];
  } GPUmesh;

extern GLuint rend_program_id[2];
extern GLuint rend_program0_uvloc[2];
extern GLuint rend_program1_uvloc[5];
extern GLuint trbuf;
extern GLint  trbofs[4];
extern GLuint empty_vao;

void LoadMeshRefinementShaders ( void );
void DestroyMeshRefinementShaders ( void );
void LoadMeshRenderingShaders ( void );
void DestroyMeshRenderingShaders ( void );

char ReallocGPUmesh ( GPUmesh *gmesh, int nsattr, int nv, int nhe, int nfac );
char ReallocCPUmesh ( CPUmesh *cmesh, int nsattr, int nv, int nhe, int nfac );
void FreeCPUmeshTab ( CPUmesh *cmesh );
char CPUmeshToGPU ( CPUmesh *cmesh, GPUmesh *gmesh );
char GPUmeshToCPU ( GPUmesh *gmesh, CPUmesh *cmesh );
void DeleteCPUmesh ( CPUmesh *cmesh );
void DeleteGPUmesh ( GPUmesh *gmesh );

char GPUmeshDoubling ( GPUmesh *inmesh, GPUmesh *outmesh );
char GPUmeshAveraging ( GPUmesh *inmesh, GPUmesh *outmesh );
char GPUmeshRefinement ( int n, GPUmesh *inmesh, GPUmesh *outmesh );

void DrawMeshEdges ( GPUmesh *mesh, GLfloat colour[4] );
void DrawMeshFacets ( GPUmesh *mesh, GLfloat colour[4] );

